/*
 * $Id: screen.c,v 1.3 2003/02/09 07:34:16 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * SDL screen handler.
 *
 * @version $Revision: 1.3 $
 */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include "SDL.h"
#include <pspdebug.h>
#include "noiz2sa.h"
#include "screen.h"
#include "clrtbl.h"
#include "vector.h"
#include "degutil.h"
#include "letterrender.h"
#include "attractmanager.h"

#include "imageio.h"
#include <math.h>
#include "colors.h"

#define SLICE_SIZE 64 // change this to experiment with different page-cache sizes

#define pg_vramtop ((char *)0x04000000)
static unsigned int __attribute__((aligned(16))) list[262144];
unsigned short __attribute__((aligned(16))) pixels[512*480];
struct Vertex
{
        unsigned short u, v;
        unsigned short color;
        short x, y, z;
};

	unsigned int j;
        struct Vertex* vertices;

long pg_screenmode;

long pg_showframe;
SceCtrlData cpad;

int line=1;

int windowMode = 0;
int brightness = DEFAULT_BRIGHTNESS;

//static SDL_Surface *video, *layer, *lpanel, *rpanel;
static LayerBit **smokeBuf;
static LayerBit *pbuf;
LayerBit *l1buf, *l2buf;
LayerBit *lbuf;
LayerBit *lpbuf, *rpbuf;
//static SDL_Rect screenRect, layerRect, layerClearRect;
//static SDL_Rect lpanelRect, rpanelRect, panelClearRect;
//static int pitch, ppitch;
#define pitch 512

// Handle BMP images.
#define SPRITE_NUM 9 

long pg_drawframe=0;
IMAGE *images[SPRITE_NUM];
//static SDL_Surface *sprite[SPRITE_NUM];
static char *spriteFile[SPRITE_NUM] = {
  "title_n.bmp", "title_o.bmp", "title_i.bmp", "title_z.bmp", "title_2.bmp", 
  "title_s.bmp", "title_a.bmp", "left_panel.bmp" , "right_panel.bmp"
};

//SDL_Joystick *stick = NULL;

unsigned short blend(unsigned short c1, unsigned short c2){ 
	return (unsigned short)(((c1 & 0xF7BC)>>1) + ((c2 & 0xF7BC)>>1)); 
}
//unsigned short blend(unsigned short a, unsigned short b){
//	return (unsigned short)(((((a & 0x7c1f) + (b & 0x7c1f) + 0x401) >> 1) & 0x7c1f) | ((((a & 0x03e0) + (b & 0x03e0) + 0x20) >> 1) & 0x03e0));
//}


void guInit(void) {
	sceGuInit();
	sceGuStart(GU_DIRECT,list);
        sceGuDrawBuffer(GU_PSM_5551,(void*)0,512);
        sceGuDispBuffer(480,272,(void*)0x88000,512);
        sceGuDepthBuffer((void*)0x110000,512);
        sceGuOffset(2048 - (480/2),2048 - (272/2));
        sceGuViewport(2048,2048,480,272);
        sceGuDepthRange(0xc350,0x2710);
        sceGuScissor(0,0,480,272);
        sceGuEnable(GU_SCISSOR_TEST);
        sceGuFrontFace(GU_CW);
        sceGuEnable(GU_TEXTURE_2D);
        sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
        sceGuFinish();
        sceGuSync(0,0);

        //sceDisplayWaitVblankStart();
        sceGuDisplay(1);

}

void guBlit () {
	sceKernelDcacheWritebackAll();
	sceGuStart(GU_DIRECT,list);


	sceGuEnable(GU_SCISSOR_TEST);
	sceGuScissor(0,0,480,272);
	sceGuDisable(GU_DEPTH_TEST);
  	sceGuDisable(GU_ALPHA_TEST);





        sceGuTexMode(GU_PSM_5551,0,0,0);
        sceGuTexImage(0,512,512,512,pixels);
       // sceGuTexFlush();
        sceGuTexFunc(GU_TFX_REPLACE,GU_TCC_RGB);
       	sceGuTexFilter(GU_LINEAR,GU_LINEAR);
        //sceGuTexFilter(GU_NEAREST_MIPMAP_NEAREST,GU_NEAREST_MIPMAP_NEAREST);
        sceGuTexScale(1,1);
        sceGuTexOffset(0.0f,0.0f);
        sceGuAmbientColor(BGMAIN_COLOR);

	for (j = 0; (j+SLICE_SIZE) <= 512; j = j+SLICE_SIZE) {
		vertices = (struct Vertex*)sceGuGetMemory(2 * sizeof(struct Vertex));

       		vertices[0].u = j; vertices[0].v = 0;
                vertices[0].x = j*480/512; vertices[0].y = 0; vertices[0].z = 0;
                vertices[1].u = j+SLICE_SIZE; vertices[1].v = 480;
                vertices[1].x = (j+SLICE_SIZE)*480/512; vertices[1].y = 272; vertices[1].z = 0;

                sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_5551|GU_VERTEX_16BIT|GU_TRANSFORM_2D,2,0,vertices);

                }

	sceGuFinish();
	sceGuSync(0,0);
	//sceDisplayWaitVblankStart();
	sceGuSwapBuffers();
}

char *pgGetVramAddr(unsigned long x,unsigned long y)
{
	return  pg_vramtop+pg_drawframe*FRAMESIZE+x*PIXELSIZE*2+y*LINESIZE*2+0x40000000;
}


void freeSprites()  {
 int i;
 for ( i=0 ; i<SPRITE_NUM ; i++ )
		 image_free(images[i]);
}

static void loadSprites() {
  FILE *fp ;
  int i;
  s32 r,g,b;
  int j;
  char name[32];
  for ( i=0 ; i<SPRITE_NUM ; i++ ) {
    strcpy(name, "images/");
    strcat(name, spriteFile[i]);
    fp=fopen(name, "rb");
    if (fp!=NULL) {
	images[i]=load_bmp(fp);

	//set up the pallette
	s32 r,g,b;
	for(j=0;j<images[i]->n_palette;j++){
	  r=(s32)(images[i]->palette[j].r);
	  g=(s32)(images[i]->palette[j].g);
	  b=(s32)(images[i]->palette[j].b);
	  images[i]->pal[j] = RGB(r,g,b);
	}


	fclose(fp);
    }
  }

}



void drawSprite(int n, int x0, int y0) {
	unsigned short *dst =  &pixels[y0*512+x0];
	unsigned char* src = (unsigned char*)images[n]->pixels;

	int x,y;
	for(y=0;y<images[n]->height;y++) {
		for(x=0;x<images[n]->width;x++) {
			dst[x] = images[n]->pal[*src++];
		}
		dst += 512;
	}
}

void drawSpritePart(int n, int x0, int y0,int ox, int oy,int w, int h) {
	unsigned short *dst =  &pixels[y0*512+x0];
	unsigned char* src = (unsigned char*)images[n]->pixels+images[n]->width*oy+ox;

	int x,y;
	for(y=0;y<h;y++) {
		for(x=0;x<w;x++) {
			dst[x] = images[n]->pal[*src++];
		}
		dst += 512;
		src=src+images[n]->width-w;
	}
}


// Initialize palletes.
static void initPalette() {
  /*int i;
  for ( i=0 ; i<256 ; i++ ) {
    color[i].r = color[i].r*brightness/256;
    color[i].g = color[i].g*brightness/256;
    color[i].b = color[i].b*brightness/256;
  }
  SDL_SetColors(video, color, 0, 256);
  SDL_SetColors(layer, color, 0, 256);
  SDL_SetColors(lpanel, color, 0, 256);
  SDL_SetColors(rpanel, color, 0, 256);
*/
}

static int lyrSize;

static void makeSmokeBuf() {
  int x, y, mx, my;
  lyrSize = sizeof(LayerBit)*pitch*SCREEN_HEIGHT;
  if ( NULL == (smokeBuf = (LayerBit**)malloc(sizeof(LayerBit*)*pitch*SCREEN_HEIGHT)) ) {
    //fprintf(stderr, "Couldn't malloc smokeBuf.");
    exit(1);
  }
  if ( NULL == (pbuf  = (LayerBit*)malloc(lyrSize+sizeof(LayerBit))) ||
       NULL == (l1buf = (LayerBit*)malloc(lyrSize+sizeof(LayerBit))) ||
       NULL == (l2buf = (LayerBit*)malloc(lyrSize+sizeof(LayerBit))) ) {
    //fprintf(stderr, "Couldn't malloc buffer.");
    exit(1);
  }
  pbuf[pitch*SCREEN_HEIGHT] = 0;
  for ( y=0 ; y<SCREEN_HEIGHT ; y++ ) {
    for ( x=0 ; x<SCREEN_WIDTH ; x++ ) {
      mx = x + sctbl[(x*8)&(DIV-1)]/128;
      my = y + sctbl[(y*8)&(DIV-1)]/128;
      if ( mx < 0 || mx >= SCREEN_WIDTH || my < 0 || my >= SCREEN_HEIGHT ) {
	smokeBuf[x+y*pitch] = &(pbuf[pitch*SCREEN_HEIGHT]);
      } else {	
	smokeBuf[x+y*pitch] = &(pbuf[mx+my*pitch]);
      }
    }
  }
}

void initSDL(void) {
   setColors();
   sceCtrlSetSamplingCycle(0);
   sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
    //pgInit();
    //pgScreenFrame(2,0);


  /*
  Uint8 videoBpp;
  Uint32 videoFlags;
  SDL_PixelFormat *pfrm;


  if ( SDL_Init(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK) < 0 ) {
    fprintf(stderr, "Unable to initialize SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);

  videoBpp = BPP;
  videoFlags = SDL_DOUBLEBUF | SDL_HWSURFACE | SDL_HWPALETTE;
  if ( !window ) videoFlags |= SDL_FULLSCREEN;

  if ( (video = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, videoBpp, videoFlags)) == NULL ) {
    fprintf(stderr, "Unable to create SDL screen: %s\n", SDL_GetError());
    SDL_Quit();
    exit(1);
  }
  screenRect.x = screenRect.y = 0;
  screenRect.w = SCREEN_WIDTH; screenRect.h = SCREEN_HEIGHT;
  pfrm = video->format;
  if ( NULL == ( layer = SDL_CreateRGBSurface
		(SDL_SWSURFACE, SCREEN_WIDTH, SCREEN_HEIGHT, videoBpp,
		 pfrm->Rmask, pfrm->Gmask, pfrm->Bmask, pfrm->Amask)) ||
       NULL == ( lpanel = SDL_CreateRGBSurface
		(SDL_SWSURFACE, PANEL_WIDTH, PANEL_HEIGHT, videoBpp,
		 pfrm->Rmask, pfrm->Gmask, pfrm->Bmask, pfrm->Amask)) ||
       NULL == ( rpanel = SDL_CreateRGBSurface
		(SDL_SWSURFACE, PANEL_WIDTH, PANEL_HEIGHT, videoBpp,
		 pfrm->Rmask, pfrm->Gmask, pfrm->Bmask, pfrm->Amask)) ) {
      fprintf(stderr, "Couldn't create surface: %s\n", SDL_GetError());
      exit(1);
  }
  layerRect.x = (SCREEN_WIDTH-SCREEN_WIDTH)/2;
  layerRect.y = (SCREEN_HEIGHT-SCREEN_HEIGHT)/2;
  layerRect.w = SCREEN_WIDTH;
  layerRect.h = SCREEN_HEIGHT;
  layerClearRect.x = layerClearRect.y = 0;
  layerClearRect.w = SCREEN_WIDTH;
  layerClearRect.h = SCREEN_HEIGHT;
  lpanelRect.x = 0;
  lpanelRect.y = (SCREEN_HEIGHT-PANEL_HEIGHT)/2;
  rpanelRect.x = SCREEN_WIDTH-PANEL_WIDTH;
  rpanelRect.y = (SCREEN_HEIGHT-PANEL_HEIGHT)/2;
  lpanelRect.w = rpanelRect.w = PANEL_WIDTH;
  lpanelRect.h = rpanelRect.h = PANEL_HEIGHT;
  panelClearRect.x = panelClearRect.y = 0;
  panelClearRect.w = PANEL_WIDTH;
  panelClearRect.h = PANEL_HEIGHT;

  pitch = layer->pitch/(videoBpp/8);
  lbuf = (LayerBit*)layer->pixels;
  ppitch = lpanel->pitch/(videoBpp/8);
  lpbuf = (LayerBit*)lpanel->pixels;
  rpbuf = (LayerBit*)rpanel->pixels;
*/
  initPalette();
  //makeSmokeBuf();

  loadSprites();

 // stick = SDL_JoystickOpen(0);

  //SDL_WM_SetCaption(CAPTION, NULL);
  //SDL_ShowCursor(SDL_DISABLE);
  //SDL_WM_GrabInput(SDL_GRAB_ON);
}

void closeSDL() {
  //SDL_ShowCursor(SDL_ENABLE);
}

void blendScreen() {
  int i;
/*
  for ( i = lyrSize-1 ; i >= 0 ; i-- ) {
    lbuf[i] = colorAlp[l1buf[i]][l2buf[i]];
  }
*/
}

void flipScreen() {
  if ( status == TITLE ) {
    drawTitle();
  }
  guBlit();
/*
  pg_showframe=pg_drawframe;
  pg_drawframe++;
  pg_drawframe&=1;	
  sceDisplaySetFrameBuf(pg_vramtop+pg_showframe*FRAMESIZE,LINESIZE,PIXELSIZE,0);
  //SDL_BlitSurface(layer, NULL, video, &layerRect);
  //SDL_BlitSurface(lpanel, NULL, video, &lpanelRect);
  //SDL_BlitSurface(rpanel, NULL, video, &rpanelRect);
  //SDL_Flip(video);
*/
}

void clearAllScreen() {

	int x,y;
	for (y = 0; y < 480; ++y) {
		unsigned short* row = &pixels[y * 512];
		for (x = 0; x < 512; ++x) {
				row[x]=BGMAIN_COLOR;
		}
	} 

}



void clearScreen() {
	int x,y;
	for (y = 0; y < 480; ++y) {
		unsigned short* row = &pixels[y * 512];
		for (x = 90; x < 410; ++x) {
				row[x]=BGMAIN_COLOR;
		}
	} 
}


void clearPanels() {
   drawSprite(7, 0, 0);
   drawSprite(8, 412, 0); 
}

void clearLPanel() {
   drawSpritePart(7, 8,180,8,180,74,300);
   drawSpritePart(7, 8,22,8,22,41,110);
}

void clearRPanel() {
   drawSpritePart(8,414,2,2,2,26,300);
   drawSpritePart(8,442,2,30,2,64,240);
   drawSpritePart(8,442,420,30,420,64,60);
}

void smokeScreen() {
  int i;
  memcpy(pbuf, l2buf, lyrSize);
  for ( i = lyrSize-1 ; i >= 0 ; i-- ) {
    //l1buf[i] = colorDfs[l1buf[i]];
    //l2buf[i] = colorDfs[*(smokeBuf[i])];
  }
}



void drawLine(int x1,int y1,int x2,int y2, LayerBit color, int width) {
  int lx, ly, ax, ay, x, y, ptr, i, j;
  int xMax, yMax;
  unsigned short *vptr0;		//pointer to vram

  vptr0=&pixels[0];
  lx = abs(x2 - x1);
  ly = abs(y2 - y1);
  if ( lx < ly ) {
    x1 -= width>>1; x2 -= width>>1;
  } else {
    y1 -= width>>1; y2 -= width>>1;
  }
  xMax = LAYER_WIDTH-width-1; yMax = LAYER_HEIGHT-width-1;

  if ( x1 < 0 ) {
    if ( x2 < 0 ) return;
    y1 = (y1-y2)*x2/(x2-x1)+y2;
    x1 = 0;
  } else if ( x2 < 0 ) {
    y2 = (y2-y1)*x1/(x1-x2)+y1;
    x2 = 0;
  }
  if ( x1 > xMax ) {
    if ( x2 > xMax ) return;
    y1 = (y1-y2)*(x2-xMax)/(x2-x1)+y2;
    x1 = xMax;
  } else if ( x2 > xMax ) {
    y2 = (y2-y1)*(x1-xMax)/(x1-x2)+y1;
    x2 = xMax;
  }
  if ( y1 < 0 ) {
    if ( y2 < 0 ) return;
    x1 = (x1-x2)*y2/(y2-y1)+x2;
    y1 = 0;
  } else if ( y2 < 0 ) {
    x2 = (x2-x1)*y1/(y1-y2)+x1;
    y2 = 0;
  }
  if ( y1 > yMax ) {
    if ( y2 > yMax ) return;
    x1 = (x1-x2)*(y2-yMax)/(y2-y1)+x2;
    y1 = yMax;
  } else if ( y2 > yMax ) {
    x2 = (x2-x1)*(y1-yMax)/(y1-y2)+x1;
    y2 = yMax;
  }

  lx = abs(x2 - x1);
  ly = abs(y2 - y1);

//lets add offset to x coords
  x2+=90;
  x1+=90;

  if ( lx < ly ) {
    if ( ly == 0 ) ly++;
    ax = ((x2 - x1)<<8) / ly;
    ay = ((y2 - y1)>>8) | 1;
    x  = x1<<8;
    y  = y1;
    for ( i=ly ; i>0 ; i--, x+=ax, y+=ay ){
      ptr = y*pitch + (x>>8);
      for ( j=width ; j>0 ; j--, ptr++ ) {
	vptr0[ptr] = color;
      }
    }
  } else {
    if ( lx == 0 ) lx++;
    ay = ((y2 - y1)<<8) / lx;
    ax = ((x2 - x1)>>8) | 1;
    x  = x1;
    y  = y1<<8;
    for ( i=lx ; i>0 ; i--, x+=ax, y+=ay ) {
      ptr = (y>>8)*pitch + x;
      for ( j=width ; j>0 ; j--, ptr+=pitch ) {
	vptr0[ptr] = color;
      }
    }
  }
}

void drawThickLine(int x1, int y1, int x2, int y2, LayerBit color1, LayerBit color2, int width) {
  int lx, ly, ax, ay, x, y, ptr, i, j, kk;
  int xMax, yMax;
  int width1;
  unsigned short *vptr0;		//pointer to vram

  vptr0=&pixels[0];

  lx = abs(x2 - x1);
  ly = abs(y2 - y1);
  if ( lx < ly ) {
    x1 -= width>>1; x2 -= width>>1;
  } else {
    y1 -= width>>1; y2 -= width>>1;
  }
  xMax = LAYER_WIDTH-width; yMax = LAYER_HEIGHT-width;

  if ( x1 < 0 ) {
    if ( x2 < 0 ) return;
    y1 = (y1-y2)*x2/(x2-x1)+y2;
    x1 = 0;
  } else if ( x2 < 0 ) {
    y2 = (y2-y1)*x1/(x1-x2)+y1;
    x2 = 0;
  }
  if ( x1 > xMax ) {
    if ( x2 > xMax ) return;
    y1 = (y1-y2)*(x2-xMax)/(x2-x1)+y2;
    x1 = xMax;
  } else if ( x2 > xMax ) {
    y2 = (y2-y1)*(x1-xMax)/(x1-x2)+y1;
    x2 = xMax;
  }
  if ( y1 < 0 ) {
    if ( y2 < 0 ) return;
    x1 = (x1-x2)*y2/(y2-y1)+x2;
    y1 = 0;
  } else if ( y2 < 0 ) {
    x2 = (x2-x1)*y1/(y1-y2)+x1;
    y2 = 0;
  }
  if ( y1 > yMax ) {
    if ( y2 > yMax ) return;
    x1 = (x1-x2)*(y2-yMax)/(y2-y1)+x2;
    y1 = yMax;
  } else if ( y2 > yMax ) {
    x2 = (x2-x1)*(y1-yMax)/(y1-y2)+x1;
    y2 = yMax;
  }

  lx = abs(x2 - x1);
  ly = abs(y2 - y1);
  width1 = width - 2;
//lets add offset to x coords
  x2+=90;
  x1+=90;

  if ( lx < ly ) {
    if ( ly == 0 ) ly++;
    ax = ((x2 - x1)<<8) / ly;
    ay = ((y2 - y1)>>8) | 1;
    x  = x1<<8;
    y  = y1;
    ptr = y*pitch + (x>>8) + 1;
    for(j=0; j<width1; j++) {
    		vptr0[ptr + j] = color2;
    }
    // memset(&vptr0[ptr], color2, 2*width1);

    x += ax; y += ay;
    for ( i = ly-1 ; i > 1 ; i--, x+=ax, y+=ay ){
      ptr = y*pitch + (x>>8);
      ((unsigned short *)vptr0)[ptr] = color2; ptr++;
      for(j=0; j<width1; j++) {
    		vptr0[ptr + j] = color1;
	}
	//memset(&vptr0[ptr], color1, 2*width1); 
     ptr += width1;
      ((unsigned short *)vptr0)[ptr] = color2;
    }
    ptr = y*pitch + (x>>8) + 1;
    for(j=0; j<width1; j++) {
    	vptr0[ptr + j] = color2;
    }
    //memset(&vptr0[ptr], color2, 2*width1);
  } else {
    if ( lx == 0 ) lx++;
    ay = ((y2 - y1)<<8) / lx;
    ax = ((x2 - x1)>>8) | 1;
    x  = x1;
    y  = y1<<8;
    ptr = ((y>>8)+1)*pitch + x;
    for ( j=width1 ; j>0 ; j--, ptr+=pitch ) {
      ((unsigned short *)vptr0)[ptr] = color2;
    }
    x += ax; y += ay;
    for ( i=lx-1 ; i>1 ; i--, x+=ax, y+=ay ) {
      ptr = (y>>8)*pitch + x;
      ((unsigned short *)vptr0)[ptr] = color2; ptr += pitch;
      for ( j=width1 ; j>0 ; j--, ptr+=pitch ) {
	((unsigned short *)vptr0)[ptr] = color1;
      }
      ((unsigned short *)vptr0)[ptr] = color2;
    }
    ptr = ((y>>8)+1)*pitch + x;
    for ( j=width1 ; j>0 ; j--, ptr+=pitch ) {
      ((unsigned short *)vptr0)[ptr] = color2;
    }
  }
}



void drawBoxPanel(int x, int y, int width, int height, LayerBit color1, LayerBit color2) {
  int i, j;
  int ptr;

  unsigned short *vptr0;		//pointer to vram
  vptr0=&pixels[0];


  x -= width>>1; y -= height>>1;
  if ( x < 0 ) {
    width += x; x = 0;
  }
  if ( x+width >= SCREEN_WIDTH ) {
    width = SCREEN_WIDTH-x;
  }
  if ( width <= 1 ) return;
  if ( y < 0 ) {
    height += y; y = 0;
  }
  if ( y+height > SCREEN_HEIGHT ) {
    height = SCREEN_HEIGHT-y;
  }
  if ( height <= 1 ) return;

  ptr = x + y*SCREEN_WIDTH;
  for (i=0; i<width; i++)
  	vptr0[ptr+i]=color2;
  y++;
  for ( i=1 ; i<height-2 ; i++, y++ ) {
    ptr = x + y*SCREEN_WIDTH;
    ((unsigned short *)vptr0)[ptr] = color2; ptr++;
    for(j=0; j<width-2; j++)
    	vptr0[ptr+j]=color1;
    ptr += width-2;
    ((unsigned short *)vptr0)[ptr] = color2;
  }
  ptr = x + y*SCREEN_WIDTH;
  for (i=0; i<width; i++)
  	vptr0[ptr+i]=color2;
}

void drawWireBox(int x, int y, int width, int height, 
		  LayerBit color1, LayerBit color2) {
  int i, j;
  int ptr;
  unsigned short *vptr0;		//pointer to vram

  vptr0=&pixels[0];

  x -= width>>1; y -= height>>1;
  if ( x < 0 ) {
    width += x; x = 0;
  }
  if ( x+width >= LAYER_WIDTH ) {
    width = LAYER_WIDTH-x;
  }
  if ( width <= 1 ) return;
  if ( y < 0 ) {
    height += y; y = 0;
  }
  if ( y+height > LAYER_HEIGHT ) {
    height = LAYER_HEIGHT-y;
  }
  if ( height <= 1 ) return;

 x+=90; //offset of the panel
  ptr = x + y*SCREEN_WIDTH;
  for (i=0; i<width; i++)
  	((unsigned short *)vptr0)[ptr+i]=color2;
  y++;
  for ( i=0 ; i<height-2 ; i++, y++ ) {
    ptr = x + y*SCREEN_WIDTH;
    ((unsigned short *)vptr0)[ptr] = color2; ptr++;
    ptr += width-2;
    ((unsigned short *)vptr0)[ptr] = color2;
  }
  ptr = x + y*SCREEN_WIDTH;
  for (i=0; i<width; i++)
  	((unsigned short *)vptr0)[ptr+i]=color2;
}

void drawBox(int x, int y, int width, int height, 
		  LayerBit color1, LayerBit color2) {
  int i, j;
  int ptr;
  unsigned short *vptr0;		//pointer to vram

  vptr0=&pixels[0];

  x -= width>>1; y -= height>>1;
  if ( x < 0 ) {
    width += x; x = 0;
  }
  if ( x+width >= LAYER_WIDTH ) {
    width = LAYER_WIDTH-x;
  }
  if ( width <= 1 ) return;
  if ( y < 0 ) {
    height += y; y = 0;
  }
  if ( y+height > LAYER_HEIGHT ) {
    height = LAYER_HEIGHT-y;
  }
  if ( height <= 1 ) return;

 x+=90; //offset of the panel
  ptr = x + y*SCREEN_WIDTH;
  for (i=0; i<width; i++)
  	((unsigned short *)vptr0)[ptr+i]=color2;
  y++;
  for ( i=0 ; i<height-2 ; i++, y++ ) {
    ptr = x + y*SCREEN_WIDTH;
    ((unsigned short *)vptr0)[ptr] = color2; ptr++;
    for(j=0; j<width-2; j++)
    	((unsigned short *)vptr0)[ptr+j]=color1;
    ptr += width-2;
    ((unsigned short *)vptr0)[ptr] = color2;
  }
  ptr = x + y*SCREEN_WIDTH;
  for (i=0; i<width; i++)
  	((unsigned short *)vptr0)[ptr+i]=color2;
}

// Draw the numbers.
int drawNum(int n, int x ,int y, int s, int c1, int c2) {
  for ( ; ; ) {
    drawLetter(n%10, x, y, s, 1, c1, c2 );
    y += s*1.7f;
    n /= 10;
    if ( n <= 0 ) break;
  }
  return y;
}

int drawNumRight(int n, int x ,int y, int s, int c1, int c2) {
  int d, nd, drawn = 0;
  for ( d = 100000000 ; d > 0 ; d /= 10 ) {
    nd = (int)(n/d);
    if ( nd > 0 || drawn ) {
      n -= d*nd;
      drawLetter(nd%10, x, y, s, 3, c1, c2 );
      y += s*1.7f;
      drawn = 1;
    }
  }
  if ( !drawn ) {
    drawLetter(0, x, y, s, 3, c1, c2);
    y += s*1.7f;
  }
  return y;
}

int drawNumCenter(int n, int x ,int y, int s, int c1, int c2) {
  for ( ; ; ) {
    drawLetterBuf(n%10, x, y, s, 2, c1, c2,  0);
    x -= s*1.7f;
    n /= 10;
    if ( n <= 0 ) break;
  }
  return y;
}



int getPadState() {
  int pad = 0;
  sceCtrlPeekBufferPositive(&cpad, 1); 
  
  if ((cpad.Buttons & PSP_CTRL_UP) || (cpad.Ly <= 0x30)) 
    	pad |= PAD_UP;
  if ((cpad.Buttons & PSP_CTRL_DOWN) || (cpad.Ly >= 0xD0))
    	pad |= PAD_DOWN;
  if ((cpad.Buttons & PSP_CTRL_LEFT) || (cpad.Lx <= 0x30))
    	pad |= PAD_LEFT;
  if ((cpad.Buttons & PSP_CTRL_RIGHT) || (cpad.Lx >= 0xD0))
    	pad |= PAD_RIGHT;
  return pad;
}

int buttonReversed = 0;

int getButtonState() {
  int btn = 0;
  sceCtrlReadBufferPositive(&cpad, 1); 
  if (cpad.Buttons & PSP_CTRL_CROSS) {
    if ( !buttonReversed ) {
      btn |= PAD_BUTTON1;
    } else {
      btn |= PAD_BUTTON2;
    }
  }
  if (cpad.Buttons &  PSP_CTRL_RTRIGGER) {
    if ( !buttonReversed ) {
      btn |= PAD_BUTTON2;
    } else {
      btn |= PAD_BUTTON1;
    }
  }
  return btn;
}



void pgInit()
{
        //pspDisplaySetMode(0,SCREEN_WIDTH,SCREEN_HEIGHT);
        pgScreenFrame(2,1);
}


void pgScreenFrame(long mode,long frame)
{
        pg_screenmode=mode;
        frame=(frame?1:0);
        pg_showframe=frame;
        if (mode==0) {
                //screen off
                pg_drawframe=frame;
                sceDisplaySetFrameBuf(0,0,0,1);
        } else if (mode==1) {
                //show/draw same
                pg_drawframe=frame;
                sceDisplaySetFrameBuf(pg_vramtop+(pg_showframe?FRAMESIZE:0),LINESIZE,PIXELSIZE,1);
        } else if (mode==2) {
                //show/draw different
                pg_drawframe=(frame?0:1);
                sceDisplaySetFrameBuf(pg_vramtop+(pg_showframe?FRAMESIZE:0),LINESIZE,PIXELSIZE,1);
        }
}



