/*
 * $Id: screen.h,v 1.3 2002/12/31 09:34:34 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * SDL screen functions header file.
 *
 * @version $Revision: 1.3 $
 */

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <psppower.h>
#include <pspgu.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "imageio.h"
//#include "vector.h"

#define RGB(r,g,b) (short)((((b>>3) & 0x1F)<<10)|(((g>>3) & 0x1F)<<5)|(((r>>3) & 0x1F)<<0)|0x8000)
#define SCREEN_WIDTH 512 
#define SCREEN_HEIGHT 480 
#define LAYER_WIDTH 320 
#define LAYER_HEIGHT 480 
#define PANEL_WIDTH 320 
#define PANEL_HEIGHT 480 

#define SCAN_WIDTH  320 
#define SCAN_HEIGHT  480
#define SCAN_WIDTH_8 (SCAN_WIDTH<<8)
#define SCAN_HEIGHT_8 (SCAN_HEIGHT<<8)

#define VRAM_ADDR       (0x04000000)


#define PIXELSIZE       1                               //in short
#define LINESIZE        512                             //in short
#define FRAMESIZE       0x44000                 //in byte


#define BPP 8
#define LayerBit unsigned short 

#define PAD_UP 1
#define PAD_DOWN 2
#define PAD_LEFT 4
#define PAD_RIGHT 8
#define PAD_BUTTON1 16
#define PAD_BUTTON2 32

#define DEFAULT_BRIGHTNESS 224

/*
extern int windowMode;
extern LayerBit *l1buf, *l2buf;
extern LayerBit *buf;
extern LayerBit *lpbuf, *rpbuf;
extern Uint8 *keys;
extern SDL_Joystick *stick;
extern int buttonReversed;
extern int brightness;
*/


void initSDL(void);
void closeSDL();
void blendScreen();
void flipScreen();
void clearScreen();
void clearAllScreen();
void clearPanels();
void clearLPanel();
void clearRPanel();
void smokeScreen();
void drawThickLine(int x1, int y1, int x2, int y2, LayerBit color1, LayerBit color2, int width);
void drawLine(int x1, int y1, int x2, int y2, LayerBit color, int width);
void drawBox(int x, int y, int width, int height, LayerBit color1, LayerBit color2);
void drawWireBox(int x, int y, int width, int height, LayerBit color1, LayerBit color2);
void drawBoxPanel(int x, int y, int width, int height, LayerBit color1, LayerBit color2);
int drawNum(int n, int x ,int y, int s, int c1, int c2);
int drawNumRight(int n, int x ,int y, int s, int c1, int c2);
int drawNumCenter(int n, int x ,int y, int s, int c1, int c2);
void drawSprite(int n, int x, int y);
void freeSprites();
int getPadState();
int getButtonState();
void pgInit();
void pgScreenFrame(long mode,long frame);

char  *pgGetVramAddr(unsigned long x,unsigned long y);
void guInit(void);
void guBlit(void);
